import unittest
from modelverse_kernel.main import ModelverseKernel
from utils import execute_until_finished, MvSWrapper, get_inst, get_phase, get_returnvalue, get_phase_ref, read_primitive_interfaces, get_returnvalue_ref

class TestDelete(unittest.TestCase):
    def setUp(self):
        self.mvs = MvSWrapper()
        self.root = self.mvs.execute("RR", [])[0]
        self.mvk = ModelverseKernel(self.root)

        self.user_root = self.mvs.execute("CN", [])[0]
        self.user_frame = self.mvs.execute("CN", [])[0]
        self.symbols = self.mvs.execute("CN", [])[0]
        self.evalstack = self.mvs.execute("CN", [])[0]
        self.returnvalue = self.mvs.execute("CN", [])[0]
        self.phase = self.mvs.execute("CNV", ["init"])[0]

        self.mvs.execute("CD", [self.root, "user_1", self.user_root])
        self.mvs.execute("CD", [self.user_root, "frame", self.user_frame])
        self.mvs.execute("CD", [self.user_frame, "symbols", self.symbols])
        self.mvs.execute("CD", [self.user_frame, "evalstack", self.evalstack])
        self.mvs.execute("CD", [self.user_frame, "phase", self.phase])
        self.mvs.execute("CD", [self.user_frame, "returnvalue", self.returnvalue])

        execute_until_finished(self.mvk, self.mvs, "load_primitives", [])
        self.primitives = read_primitive_interfaces(self.root, self.mvs)

    def test_delete_node(self):
        v = self.mvs.execute("CN", [])[0]
        a = self.mvs.execute("CN", [])[0]
        e = self.mvs.execute("CE", [a, v])[0]
        self.helper_primitives_1_params("delete_element", v)

        self.assertEquals(self.mvs.execute("RV", [v])[0], None)
        self.assertEquals(self.mvs.execute("RE", [v])[0], [None, None])
        self.assertEquals(self.mvs.execute("RO", [v])[0], None)
        self.assertEquals(self.mvs.execute("RI", [v])[0], None)

        # The edge is gone too
        self.assertEquals(self.mvs.execute("RV", [e])[0], None)
        self.assertEquals(self.mvs.execute("RE", [e])[0], [None, None])
        self.assertEquals(self.mvs.execute("RO", [e])[0], None)
        self.assertEquals(self.mvs.execute("RI", [e])[0], None)

        # But the other node remains
        self.assertEquals(self.mvs.execute("RV", [a])[0], None)
        self.assertEquals(self.mvs.execute("RE", [a])[0], [None, None])
        self.assertNotEquals(self.mvs.execute("RO", [a])[0], None)
        self.assertNotEquals(self.mvs.execute("RI", [a])[0], None)

        r = get_returnvalue(self.root, self.mvs)
        self.assertEquals(r, False)

    def test_delete_edge(self):
        v = self.mvs.execute("CN", [])[0]
        a = self.mvs.execute("CN", [])[0]
        e = self.mvs.execute("CE", [a, v])[0]
        self.helper_primitives_1_params("delete_element", e)

        # Edge disappears
        self.assertEquals(self.mvs.execute("RV", [e])[0], None)
        self.assertEquals(self.mvs.execute("RE", [e])[0], [None, None])
        self.assertEquals(self.mvs.execute("RO", [e])[0], None)
        self.assertEquals(self.mvs.execute("RI", [e])[0], None)

        # But the nodes remains
        self.assertEquals(self.mvs.execute("RV", [a])[0], None)
        self.assertEquals(self.mvs.execute("RE", [a])[0], [None, None])
        self.assertNotEquals(self.mvs.execute("RO", [a])[0], None)
        self.assertNotEquals(self.mvs.execute("RI", [a])[0], None)

        self.assertEquals(self.mvs.execute("RV", [v])[0], None)
        self.assertEquals(self.mvs.execute("RE", [v])[0], [None, None])
        self.assertNotEquals(self.mvs.execute("RO", [v])[0], None)
        self.assertNotEquals(self.mvs.execute("RI", [v])[0], None)

        r = get_returnvalue(self.root, self.mvs)
        self.assertEquals(r, True)

    def helper_primitives_1_params(self, operation, a):
        self.actual_arg_a = self.mvs.execute("CN", [])[0]

        self.inst = self.mvs.execute("CNV", [{"value":"call"}])[0]
        self.const_a = self.mvs.execute("CNV", [{"value":"constant"}])[0]
        self.const_b = self.mvs.execute("CNV", [{"value":"constant"}])[0]
        self.const_c = self.mvs.execute("CNV", [{"value":"constant"}])[0]
        self.const_first = self.mvs.execute("CNV", [{"value":"constant"}])[0]
        self.value_a = self.mvs.execute("CNV", ["a"])[0]
        self.value_b = self.mvs.execute("CNV", ["b"])[0]
        self.value_c = self.mvs.execute("CNV", ["c"])[0]
        self.value_first = a

        self.mvs.execute("CD", [self.user_frame, "IP", self.inst])
        self.const_func = self.mvs.execute("CNV", [{"value":"constant"}])[0]
        self.mvs.execute("CD", [self.inst, "func", self.const_func])
        self.mvs.execute("CD", [self.const_func, "node", self.primitives[operation]])
        self.mvs.execute("CD", [self.inst, "next", self.const_c])
        self.mvs.execute("CD", [self.inst, "params", self.actual_arg_a])
        self.mvs.execute("CD", [self.inst, "last_param", self.actual_arg_a])
        self.mvs.execute("CD", [self.actual_arg_a, "value", self.const_first])
        self.mvs.execute("CD", [self.actual_arg_a, "name", self.value_a])
        self.mvs.execute("CD", [self.const_a, "node", self.value_a])
        self.mvs.execute("CD", [self.const_b, "node", self.value_b])
        self.mvs.execute("CD", [self.const_c, "node", self.value_c])
        self.mvs.execute("CD", [self.const_first, "node", self.value_first])

        ### Execute rules
        self.assertEquals(get_inst(self.root, self.mvs), "call")
        self.assertEquals(get_phase(self.root, self.mvs), "init")
        self.assertEquals(get_returnvalue_ref(self.root, self.mvs), self.returnvalue)
        execute_until_finished(self.mvk, self.mvs)

        self.assertEquals(get_inst(self.root, self.mvs), "constant")
        self.assertEquals(get_phase(self.root, self.mvs), "init")
        self.assertEquals(get_returnvalue_ref(self.root, self.mvs), self.returnvalue)
        execute_until_finished(self.mvk, self.mvs)

        self.assertEquals(get_inst(self.root, self.mvs), "constant")
        self.assertEquals(get_phase(self.root, self.mvs), "finish")
        self.assertEquals(get_returnvalue_ref(self.root, self.mvs), self.primitives[operation])
        execute_until_finished(self.mvk, self.mvs)

        self.assertEquals(get_inst(self.root, self.mvs), "call")
        self.assertEquals(get_phase_ref(self.root, self.mvs), self.actual_arg_a)
        self.assertEquals(get_returnvalue_ref(self.root, self.mvs), self.primitives[operation])
        execute_until_finished(self.mvk, self.mvs)

        self.assertEquals(get_inst(self.root, self.mvs), "constant")
        self.assertEquals(get_phase(self.root, self.mvs), "init")
        execute_until_finished(self.mvk, self.mvs)

        self.assertEquals(get_inst(self.root, self.mvs), "constant")
        self.assertEquals(get_phase(self.root, self.mvs), "finish")
        self.assertEquals(get_returnvalue_ref(self.root, self.mvs), self.value_first)
        execute_until_finished(self.mvk, self.mvs)

        self.assertEquals(get_inst(self.root, self.mvs), "call")
        self.assertEquals(get_phase(self.root, self.mvs), "call")
        self.assertEquals(get_returnvalue_ref(self.root, self.mvs), self.value_first)
        execute_until_finished(self.mvk, self.mvs)

        # Body points to empty instruction, as it is a primitive
        self.assertEquals(get_phase(self.root, self.mvs), "init")
        execute_until_finished(self.mvk, self.mvs)

        # This will have triggered the primitive, so now we are back where we left off
        # Just check whether or not the correct value is in the returnvalue to be used
        self.assertEquals(get_inst(self.root, self.mvs), "call")
        self.assertEquals(get_phase(self.root, self.mvs), "finish")
